#include <WinSock2.h>
#include <Windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <WinDivert\windivert.h>

#define MAXBUF 0xFFFF

char *Protocols[2] = {"eth_submitLogin", "eth_login"};

int ProtocolCount = 2;

bool Initial = true;

char Wallet[43] = {0};

struct Host
{
	unsigned long int Address;

	unsigned short int Port;
};

Host Hosts[256] = {0};

int HostCount = 0, HostStartIndex = 0;

static char* strnstr(const char *haystack, const char *needle, unsigned int length)
{
	size_t needleLength = strnlen(needle, length);

	if (needleLength == 0)
		return (char*) haystack;

	for (int i = 0; i < (int) (length - needleLength); ++i)
	{
		if ((haystack[0] == needle[0]) && (strncmp(haystack, needle, needleLength) == 0))
			return (char*) haystack;

		++haystack;
	}

	return 0;
}

static void Error(const char *format, ...)
{
	va_list list;

	va_start(list, format);

	vprintf(format, list);

	va_end(list);

	getchar();

	exit(EXIT_FAILURE);
}

int main(int argc, char *argv[])
{
	if (argc > 1)
	{
		Initial = false;

		memcpy(Wallet, argv[1], 42);

		printf("\n%s\n\n", Wallet);
	}

	FILE *file = fopen("hosts.txt", "r");

	if (file)
	{
		int count = 0;
		
		fscanf(file, "%d\n", &count);

		printf("%d\n\n", count);

		if (count > 1)
		{
			WSADATA wsaData;

			if (WSAStartup(MAKEWORD(2, 2), &wsaData) != 0)
				Error("WSAStartup %d\n", WSAGetLastError());

			char address[256] = {0};

			int port = 0;

			for (int i = 0; i < count; ++i)
			{
				fscanf(file, "%s %d\n", &address, &port);

				printf("[%d] %s:%d\n\n", i, address, port);

				hostent *host = gethostbyname(address);

				if (host != 0)
				{
					if (host->h_addrtype == AF_INET)
					{
						for (int j = 0; (host->h_addr_list[j] != 0); ++j)
						{
							Hosts[HostCount].Address = ((in_addr*) host->h_addr_list[j])->S_un.S_addr;
							Hosts[HostCount].Port = htons(port);

							printf("[%d] %s:%d\n", HostCount, inet_ntoa(*(in_addr*) &Hosts[HostCount].Address), htons(Hosts[HostCount].Port));

							++HostCount;
						}
					}
				}

				if (i == 0)
					HostStartIndex = HostCount;

				printf("\n");
			}

			WSACleanup();
		}

		fclose(file);
	}

	printf("\n%d\n\n", HostStartIndex);

	HANDLE handle = WinDivertOpen("ip && tcp", WINDIVERT_LAYER_NETWORK, 0, 0);

	if (handle == INVALID_HANDLE_VALUE)
		Error("WinDivertOpen %d\n", GetLastError());

	WINDIVERT_ADDRESS address;

	WINDIVERT_IPHDR *ipHeader;
	WINDIVERT_TCPHDR *tcpHeader;

	unsigned char packet[MAXBUF];

	unsigned int packetLength;

	unsigned int srcAddress = 0, dstAddress = 0;
	unsigned short int srcPort = 0, dstPort = 0;

	while (true)
	{
		if (!WinDivertRecv(handle, packet, sizeof(packet), &address, &packetLength))
		{
			printf("WinDivertRecv %d\n", GetLastError());

			continue;
		}

		char *data;

		unsigned int dataLength;

		WinDivertHelperParsePacket(packet, packetLength, &ipHeader, 0, 0, 0, &tcpHeader, 0, (void**) &data, &dataLength);

		if (address.Direction == WINDIVERT_DIRECTION_OUTBOUND)
		{
			for (int i = HostStartIndex; i < HostCount; ++i)
			{
				if ((ipHeader->DstAddr == Hosts[i].Address) && (tcpHeader->DstPort == Hosts[i].Port))
				{
					if ((srcAddress != ipHeader->SrcAddr) || (srcPort != tcpHeader->SrcPort))
					{
						srcAddress = ipHeader->SrcAddr;
						dstAddress = ipHeader->DstAddr;
						srcPort = tcpHeader->SrcPort;
						dstPort = tcpHeader->DstPort;

						printf("NoDevFee: connect [%d] %s:%d -> ", i, inet_ntoa(*(in_addr*) &ipHeader->DstAddr), htons(tcpHeader->DstPort));
						printf("[%d] %s:%d\n", 0, inet_ntoa(*(in_addr*) &Hosts[0].Address), htons(Hosts[0].Port));
					}

					ipHeader->DstAddr = Hosts[0].Address;
					tcpHeader->DstPort = Hosts[0].Port;

					break;
				}
			}
		}
		else if (address.Direction == WINDIVERT_DIRECTION_INBOUND)
		{
			if ((ipHeader->SrcAddr == Hosts[0].Address) && (ipHeader->DstAddr == srcAddress) && (tcpHeader->SrcPort == Hosts[0].Port) && (tcpHeader->DstPort == srcPort))
			{
				ipHeader->SrcAddr = dstAddress;
				tcpHeader->SrcPort = dstPort;
			}
		}

		if (dataLength > 0)
		{
			int protocol = -1;

			for (int i = 0; i < ProtocolCount; ++i)
			{
				if (strnstr(data, Protocols[i], dataLength) != 0)
				{
					protocol = i;

					break;
				}
			}

			if (protocol != -1)
			{
				char *wallet = strnstr(data, "0x", dataLength);

				if (wallet != 0)
				{
					if (Initial)
					{
						memcpy(Wallet, wallet, 42);

						Initial = false;
					}

					memcpy(wallet, Wallet, 42);

					printf("NoDevFee: %s[%d] -> %s\n", Protocols[protocol], protocol, Wallet);
				}
				else
				{
					printf("NoDevFee: %s[%d] -> Error\n", Protocols[protocol], protocol);
				}
			}
		}

		WinDivertHelperCalcChecksums(packet, packetLength, 0);

		if (!WinDivertSend(handle, packet, packetLength, &address, 0))
		{
			printf("WinDivertSendEx %d\n", GetLastError());

			continue;
		}
	}

	return EXIT_SUCCESS;
}